#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
source /opt/userful/bin/userful-bash-lib.sh
DLDEV="17e9"  #DisplayLink
MCTDEV="0711" #MCT
PATH=$PATH:/usr/X11R6/bin/
CPUTYPE=
CARDNAME=
DUALVIEW=0
TOUCHSCREEN=5
DEVTYPE=
VENDORID=
PRODUCTID=
NUM_OF_TOUCH=0
ELOTOUCH=04E7
MITOUCH=0596
OSNAME=
OSVER=
MXVER=
X_CONFIGURE=
XSERVER=
X_CONFIG_FILE="userful.xorg.conf.one"
if which lspci > /dev/null 2>&1; then
LSPCI="lspci"
else
LSPCI="/opt/userful/bin/listpci"
fi
BUSID_LEN=`$LSPCI -n | grep -m 1 "0300: " | cut -d ' ' -f 1 | wc -m`
check_dualview()
{
$LSPCI -n | grep "0300: " > /tmp/videolist.tmp
while read VIDEOENTRY; do
if echo $VIDEOENTRY | tr "[A-Z]" "[a-z]" | grep class > /dev/null 2>&1 ; then
DEVID=`echo $VIDEOENTRY | awk -- '{print $4}'`
else
DEVID=`echo $VIDEOENTRY | awk -- '{print $3}'`
fi
if grep "$DEVID" /opt/userful/bin/VGAINFO > /dev/null ; then
CARDTYPE=`grep "$DEVID" /opt/userful/bin/VGAINFO | awk -- '{print $3}'`
if [ "$CARDTYPE" == "D" ]; then
DUALVIEW=$(( $DUALVIEW + 1 ))
fi
fi
done < /tmp/videolist.tmp
}
check_laptop()
{
TMPSTR=`$LSPCI -n | grep -c "0300: "`
if [ "$TMPSTR" == "1" ]; then  # laptop has only one graphic card entity
TMPSTR=`$LSPCI -n | grep "0300: "`
if echo $TMPSTR | tr "[A-Z]" "[a-z]" | grep class > /dev/null 2>&1 ; then
VENDORID=`echo $TMPSTR | awk '{split($4,a,":"); print a[1]}'`
VIDEOID=`echo $TMPSTR | awk '{split($4,a,":"); print a[2]}'`
else
VENDORID=`echo $TMPSTR | awk '{split($3,a,":"); print a[1]}'`
VIDEOID=`echo $TMPSTR | awk '{split($3,a,":"); print a[2]}'`
fi
CARDNAME=`grep "0x"$VENDORID /etc/userful/pcitable |
grep "0x"$VIDEOID |
awk -- '{if(substr($3,2,4) == "Card") {split($0,a,"\""); print a[2]}}' |
awk -- '{split($0,b,":"); print b[2]}'`
if echo $CARDNAME | tr "[A-Z]" "[a-z]" | grep " mobility" > /dev/null 2>&1 || \
echo $CARDNAME | tr "[A-Z]" "[a-z]" | grep " igp" > /dev/null 2>&1 || \
echo $CARDNAME | tr "[A-Z]" "[a-z]" | grep " go" > /dev/null 2>&1 ; then
CPUTYPE=`grep -m 1 "model name" /proc/cpuinfo |
awk -- '{split($0,a,":"); print a[2]}'`
fi
fi
}
function check_touchscreen()
{
rm -f /tmp/touchscreen-dev
TOUCH_CNT=0
while read USBINPUT; do
if [ "${USBINPUT:0:1}" == "I" ]; then # Interface
if  echo $USBINPUT | tr "a-z" "A-Z" | grep "VENDOR=$ELOTOUCH" > /dev/null 2>&1 || \
echo $USBINPUT | tr "a-z" "A-Z" | grep "VENDOR=$MITOUCH" > /dev/null 2>&1; then
NUM_OF_TOUCH=$(( $NUM_OF_TOUCH + 1 ))
TOUCH_CNT=1
fi
elif [ "${USBINPUT:0:1}" == "N" -a $TOUCH_CNT -eq 1 ]; then # Name
if echo $USBINPUT | tr "a-z" "A-Z" | grep "NAME=" > /dev/null 2>&1 ; then
echo $USBINPUT | awk -F'=' -- '{print $2}' | tr -d "\"" >> /tmp/touchscreen-dev
TOUCH_CNT=0
fi
fi
done < /proc/bus/input/devices
while read USBDEV; do
if ! echo $USBDEV | grep "^[[:space:]]*#" > /dev/null 2>&1 && \
[ ${#USBDEV} -ne 0 ]; then
VENDORID=`echo $USBDEV | awk -- '{print $1}'`
PRODUCTID=`echo $USBDEV | awk -- '{print $2}'`
DEVTYPE=`echo $USBDEV | awk -- '{print $3}'`
if [ $DEVTYPE -eq $TOUCHSCREEN ] &&
[ "$VENDORID" != "$ELOTOUCH" -a "$VENDORID" != "$MITOUCH" ]; then
CNT=`grep -i "Vendor=$VENDORID Product=$PRODUCTID" /proc/bus/input/devices | wc -l`
if [ $CNT -gt 0 ]; then
grep -i -A 1 "Vendor=$VENDORID Product=$PRODUCTID" /proc/bus/input/devices | \
grep "N:" | awk -F'"' -- '{print $2}' >> /tmp/touchscreen-dev
NUM_OF_TOUCH=$(( $NUM_OF_TOUCH + $CNT ))
fi
fi
fi
done < /opt/userful/bin/USBINPUTTABLE
if [ -e /tmp/touchscreen-dev ]; then
cat /tmp/touchscreen-dev >>  $logfile
fi
}
function configure_mx()
{

rm -f /etc/dm-sys-info
rm -f /tmp/ret-config-message
rm -f /etc/userful/X-fail
if [ -d /usr/local/lib64 ]; then
ldconfig /usr/local/lib64/
fi
#
#
if $LSPCI -n | tr "a-z" "A-Z" | grep "0300:[[:space:]]10DE:" > /dev/null 2>&1 ; then
IS_NVIDIA_DRIVER=$(Check_nVidia_Driver)
if [[ "$IS_NVIDIA_DRIVER" == "false" ]]; then
log "nVidia driver and/or kernel module was not found."
else
log "Both nVidia card and nVidia driver/kernel module found."
fi
fi
#
#
XORG_CONF_NEW=xorg.conf.new
log "Run \"X -configure\" to create %s" "$XORG_CONF_NEW"
rm -f /root/$XORG_CONF_NEW /$XORG_CONF_NEW  2> /dev/null
#
if $LSPCI -n | tr "a-z" "A-Z" | grep "5333:8A22" > /dev/null 2>&1 ; then
:
else
date +%s > /tmp/X-start
touch /tmp/waiting-for-x
/opt/userful/bin/waiting-for.sh --xorg x &
if [ "$X_CONFIGURE" == "multi" ]; then
/opt/$MXVER/bin/Xorg -configure -logfile /var/log/mx11r7-configure.log &>/dev/null
else
$XSERVER -configure -logfile /var/log/mx11r7-configure.log &>/dev/null
fi
rm -f /tmp/X-start
if [[ ! -f /root/$XORG_CONF_NEW ]]; then
if [[ -f /$XORG_CONF_NEW ]]; then
cp -f /$XORG_CONF_NEW /root/
else
log "%s is not available." "/root/$XORG_CONF_NEW"
fi
fi
if [ -e /root/$XORG_CONF_NEW ]; then
rm -f /etc/userful/X-fail
fi
if [ ]; then
if [[ ! -f /root/$XORG_CONF_NEW ]]; then
if [[ -f /$XORG_CONF_NEW ]]; then
cp -f /$XORG_CONF_NEW /root/
else
if [ "$X_CONFIGURE" == "multi" ]; then
$XSERVER -configure &>/dev/null
else
/opt/$MXVER/bin/Xorg -configure -logfile /var/log/mx11r7-configure.log &>/dev/null
fi
if [[ ! -e /root/$XORG_CONF_NEW ]]; then
if [[ -f /$XORG_CONF_NEW ]]; then
cp -f /$XORG_CONF_NEW /root/
else
log "%s is not available." "/root/$XORG_CONF_NEW"
fi
fi
fi
fi
fi  
fi
#
/opt/userful/bin/dm-gen-xconfig.sh -one
/opt/userful/bin/dm-gen-xconfig.sh -all
#
if [ -e /tmp/Monitor.Probed ]; then
rm -f /tmp/Monitor.Probed
fi
/opt/userful/bin/umx-probe-monitor.pl >> $logfile 2>&1
if [ ! -e /tmp/Monitor.Probed ]; then
/opt/userful/bin/umx-probe-monitor.pl >> $logfile 2>&1
fi
if [ -e /tmp/Monitor.Probed ]; then
PROBED_RES=`grep -m1 "ModeLine" /tmp/Monitor.Probed | awk '{print $2}'`
if [ -z $PROBED_RES ]; then
PROBED_RES="none"
fi
fi
if [ x == x"$PROBED_RES" ]; then
PROBED_RES="none"
fi
#
/opt/userful/bin/dm-create-sysinfo.sh
#
check_laptop
check_touchscreen

rm -f /opt/userful/images/reseller-logo.jpg
if [ -x /opt/userful/bin/dm-gen-info ]; then
/opt/userful/bin/dm-gen-info -licenseinfo &>/dev/null
else
/opt/userful/bin/sno-comp
fi
source /etc/userful/userful-license-info
if [ "$RESELLER_LOGO" != "" -a -e /opt/userful/images/reseller/$RESELLER_LOGO.jpg ]; then
log "Use reseller logo: %s" "$RESELLER_LOGO.jpg"
cp -f /opt/userful/images/reseller/$RESELLER_LOGO.jpg /opt/userful/images/reseller-logo.jpg
fi
if [ -n "$XVERSION" ]; then
if [ $XVERSION -ge 16 ]; then
X_CONFIG_FILE="xorg.conf"
elif [ $XVERSION -eq 15 ]; then
if grep -q "RgbPath" /etc/X11/$X_CONFIG_FILE ; then
sed -i -e "/RgbPath/d" /etc/X11/$X_CONFIG_FILE
fi
else
sed -i -e "/\<Disable\>/d" /etc/X11/$X_CONFIG_FILE
fi
elif [ -n "$OSNAME" -a -n "$OSVER" ]; then
if [ "$OSNAME" == "ubuntu" -a "$OSVER" == "8.10" ] || \
[ "$OSNAME" == "ubuntu" -a "$OSVER" == "9.04" ] || \
[ "$OSNAME" == "suse" -a "$OSVER" == "11.0" ] || \
[ "$OSNAME" == "fedora" -a "$OSVER" == "10" ]; then 
if grep -q "RgbPath" /etc/X11/$X_CONFIG_FILE ; then
sed -i -e "/RgbPath/d" /etc/X11/$X_CONFIG_FILE
fi
else
sed -i -e "/\<Disable\>/d" /etc/X11/$X_CONFIG_FILE
fi
fi
if [ -r /etc/profile.d/lang.sh ]; then
source /etc/profile.d/lang.sh
log "FEDORA LANG=%s" "$LANG"
elif [ -r /etc/default/locale ]; then
source /etc/default/locale
log "DEB DEFAULT LANG=%s" "$LANG"
elif [ -r /etc/environment ]; then
. /etc/environment
export LANG LANGUAGE
log "DEB ENVIRONMENT LANG=%s" "$LANG"
fi
OPT_STR=""
if [ -n "$CARDNAME" -a -n "$CPUTYPE" ]; then 
OPT_STR="-cpu \"$CPUTYPE\" $OPT_STR"
sed -i -e '/SYS_TYPE=/d' /etc/dm-sys-info 2> /dev/null #/etc/dm-sys-info doesn't exist?
echo "SYS_TYPE=1" >> /etc/dm-sys-info
if [ $NUM_OF_TOUCH -gt 0 ]; then
OPT_STR="-touchscreen \"$NUM_OF_TOUCH\" $OPT_STR"
sed -i -e '/SYS_TOUCH=/d' /etc/dm-sys-info 2> /dev/null
echo "SYS_TOUCH=1" >> /etc/dm-sys-info
if [ "$IS_NVIDIA_DRIVER" == "false" ]; then
OPT_STR="-nonvidia $OPT_STR"
fi
else
if [ "$IS_NVIDIA_DRIVER" == "false" ]; then
OPT_STR="-nonvidia $OPT_STR"
fi
OPT_STR="-monitor \"$PROBED_RES\" $OPT_STR"
sed -i -e '/PROBED_RESOLUTION=/d' /etc/dm-sys-info 2> /dev/null
echo "PROBED_RESOLUTION=$PROBED_RES" >> /etc/dm-sys-info
fi
OPT_STR="-vga \"$CARDNAME\" $OPT_STR"
elif [ $NUM_OF_TOUCH -gt 0 ]; then # Normal Desktop with touchscreen
OPT_STR="-touchscreen \"$NUM_OF_TOUCH\" $OPT_STR"
if [ "$IS_NVIDIA_DRIVER" == "false" ]; then
OPT_STR="-nonvidia $OPT_STR"
fi
else # Normal desktop 
check_dualview
OPT_STR="-dualview $DUALVIEW $OPT_STR"
sed -i -e '/MAX_DUALVIEW=/d' /etc/dm-sys-info 2> /dev/null
echo "MAX_DUALVIEW=$DUALVIEW" >> /etc/dm-sys-info
if [ "$IS_NVIDIA_DRIVER" == "false" ]; then
OPT_STR="-nonvidia $OPT_STR"
fi
OPT_STR="-monitor \"$PROBED_RES\" $OPT_STR"
sed -i -e '/PROBED_RESOLUTION=/d' /etc/dm-sys-info 2> /dev/null
echo "PROBED_RESOLUTION=$PROBED_RES" >> /etc/dm-sys-info
fi
ISOLATEDEVICE=""
if [ -f /etc/X11/$X_CONFIG_FILE ]; then
nBUSID=`grep "\<BusID\>" /etc/X11/$X_CONFIG_FILE | wc -l`
if [ $nBUSID -eq 1 ]; then
B_ID=`grep "\<BusID\>" /etc/X11/$X_CONFIG_FILE | awk -F"\"" -- '{print $2}'`
ISOLATEDEVICE="-isolateDevice $B_ID"
fi
fi
if [ "$OSNAME" == "novell" -a "$OSVER" == "10" ]; then 
ISOLATEDEVICE=""
fi
if [ "$INITIAL_CONFIG" == "enable" ]; then
date +%s > /tmp/X-start
touch /tmp/waiting-for-x
/opt/userful/bin/waiting-for.sh --xorg x &
if [ -x /opt/userful/bin/display-configuration ] && [ -f /opt/userful/debug ] ; then
CONFIG_PROG=/opt/userful/bin/display-configuration
OPT_STR="-c"
else
CONFIG_PROG=/opt/userful/bin/config-message
OPT_STR="$1 $OPT_STR"
fi
xinit $CONFIG_PROG $OPT_STR -- $XSERVER -config $X_CONFIG_FILE -br $ISOLATEDEVICE  &>/dev/null
RET=`cat /tmp/ret-config-message`
if [ "$RET" == "1" ]; then
log "Use old configuration instead of creating new one."
$LSPCI -n | grep "0300: " > /etc/X11/vgainfo
return 0
fi
else
echo -e "SYS_RESOLUTION=5\nSYS_TYPE=0\nSYS_DUALVIEW=0" > /etc/dm-sys-info
fi
rm -f /etc/stations
rm -f /etc/X11/stations
rm -f /etc/X11/userful.Mxorg.conf
rm -f /etc/usbinput
rm -f /etc/X11/xdm/Xservers
rm -f /etc/mvgainfo
rm -f /etc/X11/monitors.conf
if [ -x /opt/userful/bin/dm-gen-info ]; then
/opt/userful/bin/dm-gen-info -licenseinfo &>/dev/null
else
/opt/userful/bin/sno-comp
fi
$LSPCI -n | grep "0300: " > /etc/X11/vgainfo
if [ ! -e /etc/dm-sys-info ]; then
echo "No dm-sys-info. Set default values in dm-sys-info" >> $logfile
echo -e "SYS_RESOLUTION=5\nSYS_TYPE=0\nSYS_DUALVIEW=0" > /etc/dm-sys-info
fi
/opt/userful/bin/dm-gen-xconfig.sh -check
/opt/userful/bin/ls-usb2vga > /etc/X11/usb2vgainfo
rm -f /tmp/USBMonitor.Probed /tmp/*.USBMonitor.Probed
while read DEV; do
DEVICEID=`echo $DEV | awk -F'^' '{print $1}'`
IDVENDOR=`echo $DEVICEID | awk -F':' '{print $1}'`
USBPATH=`echo $DEV | awk -F'^' '{print $2}'`
MANUFACTURER=`echo $DEV | awk -F'^' '{print $4}'`
PRODUCT=`echo $DEV | awk -F'^' '{print $5}'`
if [ "$IDVENDOR" == "$DLDEV" ]; then
DEVDRV="dl"
elif [ "$IDVENDOR" == "$MCTDEV" ]; then
DEVDRV="tusb"
else
DEVDRV="unknown"
fi
/opt/userful/bin/umx-probe-usbmonitor.pl --phys $USBPATH --driver $DEVDRV --output /tmp/$USBPATH.USBMonitor.Probed
echo "$USBPATH^$MANUFACTURER^$PRODUCT^$DEVDRV^1^$DEVICEID" >> /etc/mvgainfo
done < /etc/X11/usb2vgainfo
/opt/userful/bin/dm-gen-xconfig.sh -1box
if [ -f /etc/X11/userful.Mxorg.conf ]; then
if [ -f /opt/MX11R7/lib/libpciaccess.so ]; then
if grep -q "RgbPath" /etc/X11/userful.Mxorg.conf ; then
sed -i -e "/RgbPath/d" /etc/X11/userful.Mxorg.conf
fi
else
sed -i -e "/\<Disable\>/d" /etc/X11/userful.Mxorg.conf
fi
fi
#
if [ -e /tmp/touchscreen-dev ]; then
log "Calibration procedure starts."
/opt/userful/evtouch/calibrate.sh
fi
if [ -e /etc/userful/X-fail ]; then
sync;sync;reboot
fi
}
IsRoot
if [ -e /etc/userful/oem -a ! -e /etc/X11/1Box.info ]; then
echo
echo "Getting OEM license key...."
if [ -f /usr/share/umx-utils/install-license.sh ]; then
/usr/share/umx-utils/install-license.sh > /var/log/oem.log 2>&1
elif [ -f /usr/share/1box-utils/install-license.sh ]; then
/usr/share/1box-utils/install-license.sh > /var/log/oem.log 2>&1
fi
if [ ! -e /etc/X11/1Box.info ]; then
echo
echo "Error: Unable to get OEM license key."
cat /var/log/oem.log
sleep 3
else
echo
echo "Successfully obtained OEM license key."
sleep 3
fi
fi
if [ -f /tmp/distro.conf ]; then
source /tmp/distro.conf
fi
if [ -f /etc/userful/umx.conf ]; then
sed -e "s/^\[/#\[/g" /etc/userful/umx.conf > /tmp/umx.conf.tmp
source /tmp/umx.conf.tmp
fi
if [ -f /etc/X11/userful.Mxorg.conf ] && [ -f /opt/MX11R7/lib/libpciaccess.so ]; then

if grep -q "RgbPath" /etc/X11/userful.Mxorg.conf ; then
rm -f /etc/X11/userful.Mxorg.conf
fi
fi
source /etc/userful/os-info
if [ -n "$MXVERSION" -a -n "$XCONFIGURE" ]; then
echo "MXVER=$MXVERSION" > /etc/userful/MXVERSION
MXVER=$MXVERSION
X_CONFIGURE=$XCONFIGURE
elif [ -f /opt/MX11R7/bin/Xorg ]; then
if [ "$OSNAME" == "fedora" -a "$OSVER" == "2" -o \
"$OSNAME" == "fedora" -a "$OSVER" == "3" -o \
"$OSNAME" == "fedora" -a "$OSVER" == "4" -o \
"$OSNAME" == "novell" -a "$OSVER" == "9" -o \
"$OSNAME" == "suse" -a "$OSVER" == "9.1" -o \
"$OSNAME" == "suse" -a "$OSVER" == "9.3" -o \
"$OSNAME" == "centos" -a "$OSVER" == "4" -o \
"$OSNAME" == "freedows" -a "$OSVER" == "2005" -o \
"$OSNAME" == "ubuntu" -a "$OSVER" == "5.04" -o \
"$OSNAME" == "ubuntu" -a "$OSVER" == "5.10" -o \
"$OSNAME" == "xandros" -a "$OSVER" == "3.0" -o \
"$OSNAME" == "xandros" -a "$OSVER" == "4.0" -o \
"$OSNAME" == "morphix" -a "$OSVER" == "0.5-pre5" -o \
"$OSNAME" == "freespire" -a "$OSVER" == "1.0.4" -o \
"$OSNAME" == "debian" -a "$OSVER" == "3.1" ]; then
echo "MXVER=MX11R6" > /etc/userful/MXVERSION
MXVER=MX11R6
X_CONFIGURE="single"
elif [ "$OSNAME" == "novell" ] || [ "$OSNAME" == "suse" ]; then
echo "MXVER=MX11R7" > /etc/userful/MXVERSION
MXVER=MX11R7
X_CONFIGURE="single"
else
echo "MXVER=MX11R7" > /etc/userful/MXVERSION
MXVER=MX11R7
X_CONFIGURE="multi"
fi
else
echo "MXVER=MX11R6" > /etc/userful/MXVERSION
MXVER=MX11R6
fi
if [ "$OSNAME" == "ubuntu" ]; then
if [ "$OSVER" == "8.10" ]; then
VIDEO_RESET=disable
fi
fi
if [ -z "$XVERSION" ] || [ $XVERSION -lt 15 ]; then
if lspci -n | grep -q "1002:94c3" || \
lspci -n | grep -q "1002:9610" || \
lspci -n | grep -q "1002:9611" || \
lspci -n | grep -q "1002:95c5" ; then
X_CONFIGURE="multi"
VIDEO_RESET=disable
fi
fi
if [ -x /usr/bin/Xorg.umx-save ]; then
XSERVER="/usr/bin/Xorg.umx-save"
elif [ -x /usr/X11R6/bin/XFree86 ]; then
XSERVER="/usr/X11R6/bin/XFree86"
elif [ -x /usr/X11R6/bin/Xorg ]; then
XSERVER="/usr/X11R6/bin/Xorg"
elif [ -x /usr/bin/Xorg ]; then # For X 7.0
XSERVER="/usr/bin/Xorg"
else
XSERVER=X
fi
if [ "$VIDEO_CONF" == "static" ]; then
if [ ! -e /etc/X11/userful.Mxorg.conf ]; then
if [ -e /etc/userful/DM-install ]; then
configure_mx -f
else
configure_mx -n
fi
else
if [ ]; then
if [ ! -e /etc/userful/X-fail ] && [ "$VIDEO_RESET" != "disable" ]; then
echo "(II)VIDEO_RESET is enabled." >> $logfile
if [ "$X_CONFIGURE" == "multi" ]; then
/opt/$MXVER/bin/Xorg -configure -logfile /var/log/mx11r7-configure.log &>/dev/null
else
$XSERVER -configure &>/dev/null
fi
fi
fi
fi
else
if [ ! -e /etc/X11/userful.Mxorg.conf ]; then
if [ -e /etc/userful/DM-install ]; then
configure_mx -f  # Generate userful.Mxorg.conf
else
configure_mx -n  # Generate userful.Mxorg.conf
fi
else
if [ ! -e /etc/X11/vgainfo -o  ! -e /etc/stations -o \
! -e /etc/X11/stations -o ! -e /etc/mvgainfo ]; then
configure_mx -n  # Generate userful.Mxorg.conf
else
$LSPCI -n | grep "0300: " > /etc/X11/vgainfo.new
diff /etc/X11/vgainfo /etc/X11/vgainfo.new > /dev/null
if [ $? != 0 ];then
mv -f /etc/X11/userful.Mxorg.conf /etc/X11/userful.Mxorg.conf.old
configure_mx -r  # Generate userful.Mxorg.conf
fi
/opt/userful/bin/ls-usb2vga > /etc/X11/usb2vgainfo.new
diff /etc/X11/usb2vgainfo /etc/X11/usb2vgainfo.new > /dev/null
if [ $? != 0 ];then
mv -f /etc/X11/userful.Mxorg.conf /etc/X11/userful.Mxorg.conf.old
configure_mx -r  # Generate userful.Mxorg.conf
else
if [ ]; then
if [ ! -e /etc/userful/X-fail ] && [ "$VIDEO_RESET" != "disable" ]; then
echo "(II)VIDEO_RESET is enabled." >> $logfile
if [ "$X_CONFIGURE" == "multi" ]; then
/opt/$MXVER/bin/Xorg -configure -logfile /var/log/mx11r7-configure.log &>/dev/null
else
$XSERVER -configure &>/dev/null
fi
fi
fi
fi
fi
fi
fi
if [ -x /opt/userful/bin/dm-gen-info ]; then
/opt/userful/bin/dm-gen-info -compare &>/dev/null
else
/opt/userful/bin/sno-comp
fi
RET=$?
if [ $RET != 0 ]; then
rm -f /etc/X11/xdm/Xservers
rm -f /etc/stations
if [ -x /opt/userful/bin/dm-gen-info ]; then
/opt/userful/bin/dm-gen-info -compare &>/dev/null
else
/opt/userful/bin/sno-comp
fi
fi
if [ -x /opt/userful/bin/dm-gen-info ]; then
/opt/userful/bin/dm-gen-info -licenseinfo &>/dev/null
fi
if [ -f /etc/userful/userful-license-info ]; then
source /etc/userful/userful-license-info
if [ x"$MANDATORY_DEV" != x ] && [ $RET != 0 ]; then
rm -f /etc/usbinput
fi
fi
