#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
function start_dm()
{
source /etc/userful/os-info
if [ -f /etc/init.d/xdm.multi-save ]; then
exec /etc/init.d/xdm.multi-save start
elif [ -f /etc/init.d/kdm.multi-save ]; then
exec /etc/init.d/kdm.multi-save start
elif [ -f /etc/init.d/gdm.multi-save ]; then
exec /etc/init.d/gdm.multi-save start
elif [ -f /etc/init.d/xdm ]; then
exec /etc/init.d/xdm start
elif [ "$OSNAME" == "mandrake" ]; then
exec /etc/X11/prefdm -nodaemon
else
exec /etc/X11/prefdm -nodaemon
fi
}
if [[ -f /etc/default/locale ]]; then
echo "`date +"%b %d %T"` [$ProgramName]: source locale" >> $logfile
source /etc/default/locale 2>> $logfile
while read line; do
VARS_NAME=`echo $line | awk -F'=' '{print $1}'`
export $VARS_NAME >> $logfile
done < /etc/default/locale
if [[ -f /etc/bash.bashrc ]]; then
source /etc/bash.bashrc
fi
if [[ -f /etc/profile ]]; then
source /etc/profile
fi
if [[ -f /root/.bashrc ]]; then
source /root/.bashrc
fi
if [[ -f /root/.profile ]]; then
source /root/.profile
fi
fi
if [ -f /tmp/distro.conf ]; then
source /tmp/distro.conf
fi
if [ -f /etc/userful/umx.conf ]; then
rm -f /tmp/umx.conf.tmp
sed -e "s/^\[/#\[/g" /etc/userful/umx.conf > /tmp/umx.conf.tmp
source /tmp/umx.conf.tmp
fi
if [ "$LOGINTYPE" == "" ]; then
LOGINTYPE="local"
fi
if [ -f /etc/sysconfig/xtype ]; then
source /etc/sysconfig/xtype
fi
if [ "$XTYPE" == "" ]; then
XTYPE="SINGLE"
fi
echo "`date +"%b %d %T"` [$ProgramName]: Current XTYPE=$XTYPE, LOGINTYPE=$LOGINTYPE." >> $logfile
if [ "$XTYPE" == "SINGLE" ]; then
if [ "$LOGINTYPE" == "urls" ]; then
:
else
start_dm
fi
elif [ "$XTYPE" == "MULTI" ]; then
if [ "${LOGINTYPE//auto}" != "$LOGINTYPE" ]; then # Auto Login
sleep 1
exec /opt/userful/bin/userful-dm.sh auto
elif [ "${LOGINTYPE//remote}" != "$LOGINTYPE" ]; then # Remote Login
if [ -f /etc/init.d/iptables ]; then
/etc/init.d/iptables stop
elif [ -f /etc/init.d/SuSEfirewall2_setup ]; then
/etc/init.d/SuSEfirewall2_setup stop
fi
sleep 1
exec /opt/userful/bin/userful-dm.sh remote
elif [ "${LOGINTYPE//urls}" != "$LOGINTYPE" ]; then # URLS Login
sleep 1
if [ -n "$DMINIT" -a -e /etc/init.d/$DMINIT ]; then
if [ -n "$DMSTART" -a "$DMSTART" == "disable" ]; then
/etc/init.d/$DMINIT start
fi
fi
rm -f /var/run/pid.kbdlink*
if [ -n "$DMJOB" ]; then
DMJOBBACKUP=/etc/userful/$(basename $DMJOB).multi-save
if [ -e $DMJOBBACKUP ]; then
cp -f $DMJOBBACKUP $DMJOB
JOBNAME=`basename $DMJOB`
JOBNAME=${JOBNAME//\.conf}
initctl start $JOBNAME
sleep 1
rm -f $DMJOB
fi
fi
exec /opt/userful/bin/userful-dm.sh urls
else
if [ -n "$DMJOB" ]; then
DMJOBBACKUP=/etc/userful/$(basename $DMJOB).multi-save
if [ -e $DMJOBBACKUP ]; then
cp -f $DMJOBBACKUP $DMJOB
JOBNAME=`basename $DMJOB`
JOBNAME=${JOBNAME//\.conf}
initctl start $JOBNAME
sleep 1
rm -f $DMJOB
fi
else
start_dm  # Start Local display
fi
fi
else
echo "`date +"%b %d %T"` [$ProgramName]: Not a valid XTYPE. Check /etc/sysconfig/xtype." >> $logfile
fi
