#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
PATH=$PATH:/usr/X11R6/bin/
MAX_X_START_TIME=120
MIN_X_START_TIME=10
MXVER=MX11R6
if which lspci > /dev/null 2>&1; then
LSPCI="lspci"
else
LSPCI="/opt/userful/bin/listpci"
fi
update_mx_config()
{
NUM_OF_HEADS=`cat /etc/X11/stations`
if ! grep "tch" /etc/usbinput > /dev/null 2>&1 ; then
for ((i = 0; i < $NUM_OF_HEADS; i++))
do
TEST=`grep "InputDevice" /etc/X11/userful.Mxorg.conf | grep "Touch$i"`
if [ -n "$TEST" ]; then
sed -i -e "/$TEST/d" /etc/X11/userful.Mxorg.conf
fi
done
elif ! grep "InputDevice" /etc/X11/userful.Mxorg.conf | grep "Touch" > /dev/null 2>&1 ; then
echo "(II) Touchscreen detected. Create userful.Mxorg.conf with touchscreen infomation" >>  $logfile
if [ -f /root/xorg.conf.new ]; then
/opt/userful/bin/dm-gen-xconfig.sh -1box
else
/opt/userful/bin/mx-config-gen.sh -1box
fi
fi
}
start_mx()
{
clear
echo
echo -e "Starting \E[36mUSERFUL\033[0m Desktop Multiplier. Please wait..."
if [[ -x /opt/userful/bin/waiting-for.sh ]]; then
/opt/userful/bin/waiting-for.sh --hub -interval 3
/opt/userful/bin/waiting-for.sh --input -interval 2
fi
source /etc/userful/MXVERSION
if $LSPCI -n | grep "0300:" | tr "a-z" "A-Z" | grep "10DE" > /dev/null 2>&1 ; then
modprobe -q nvidia
fi
/opt/userful/bin/checkPS2
echo "`date +"%b %d %T"` $ProgramName: Create /etc/usbinput and symbolic link in /etc/X11/Xinput/ directory" >>  $logfile
/opt/userful/bin/make-config-file 2>> $logfile
if [ -f /opt/userful/bin/umx-mandatory-dev-refresh.sh ]; then
/opt/userful/bin/umx-mandatory-dev-refresh.sh
fi
update_mx_config
if [ -f /tmp/distro.conf]; then
source /tmp/distro.conf
fi
if [ -f /etc/userful/umx.conf ]; then
sed -e "s/^\[/#\[/g" /etc/userful/umx.conf > /tmp/umx.conf.tmp
source /tmp/umx.conf.tmp
fi
if which date > /dev/null 2>&1; then
date +%s > /tmp/X-start
else
rm -f /tmp/X-start
fi
IGNOREABI="-ignoreABI"
if [ "$MXVER" == "MX11R7" ]; then
if [ -d  /opt/MX11R7/share/X11/fonts/misc ]; then
FP="-fp /opt/MX11R7/share/X11/fonts/misc"
else
FP=""
fi
fi
if [ "$MXVER" == "MX11R7" ]; then
export LD_LIBRARY_PATH=/opt/MX11R7/lib
fi
ldconfig /opt/MX11R7/lib/
echo "`date +"%b %d %T"` $ProgramName: Start $MXVER with userful.Mxorg.conf. It may take some time." >>  $logfile
if [ "$LOGINTYPE" == "remote" ]; then
xinit /opt/userful/bin/mx.xinitrc  -- /opt/$MXVER/bin/X :0 $IGNOREABI \
-ac -br -logfile /var/log/1box-server.log -config userful.Mxorg.conf &>/dev/null &
else
xinit /opt/userful/bin/mx.xinitrc  -- /opt/$MXVER/bin/X :0 $IGNOREABI \
-br -logfile /var/log/1box-server.log -nolisten tcp -config userful.Mxorg.conf &>/dev/null &
fi
sleep 1
}
check_mx_start()
{
if which date > /dev/null 2>&1; then
START_TIME=`cat /tmp/X-start`
TIME_TAKEN=0
else
sleep 10
fi
while [ -f /tmp/X-start ]; do
NOW=`date +%s`
TIME_TAKEN=$(( $NOW - $START_TIME ))
if [ $TIME_TAKEN -gt $MIN_X_START_TIME ] ; then
pgrep X
if [ "$?" != "0" ]; then # MXserver doesn't exist.
echo "(EE) Multi-X has been crashed. See the /var/log/1box-server.log" >>  $logfile
break
fi
fi
if [ $TIME_TAKEN -gt $MAX_X_START_TIME ] ; then
pkill -9 X 2> /dev/null
sleep 5
echo "(EE) Starting Multi-X has been taken more than $MAX_X_START_TIME seconds. See the /var/log/1box-server.log" >>  $logfile
break
fi
sleep 1
done
}
start_1box_server()
{
start_mx
check_mx_start
if [ ! -e /etc/userful/start-mx ]; then
START_MX=0
else
START_MX=`cat /etc/userful/start-mx`
fi
if [ -f /tmp/X-start ] || [ -f /tmp/mx-config-error ]; then
rm -f /tmp/X-start
sleep 2
clear

START_MX=$(( $START_MX + 1 ))
echo "(EE) Multi-X has failed to start $START_MX times in a row." >>  $logfile
if [ $START_MX -eq 5 ]; then
DETAILED_MSG="(EE) Failed to start Multi-X $START_MX times. Start text login."
/usr/share/umx-utils/submit-debug-info.sh -d "$DETAILED_MSG"
echo "(EE) Start text login." >>  $logfile
echo 0 > /etc/userful/start-mx
pkill prefdm_multi
chvt 2
exit 1
elif [ $START_MX -eq 4 ]; then
DETAILED_MSG="(EE) Failed to start Multi-X with single head configuration."
echo "(II) Remove possible onboard video entry from the configuration." >>  $logfile
sed -i -e "/^1:0:0.*/d" /etc/mvgainfo
rm -f /etc/usbinput
rm -f /etc/X11/xdm/Xservers
if [ -f /root/xorg.conf.new ]; then
/opt/userful/bin/dm-gen-xconfig.sh -1box
else
pushd /opt/userful/bin > /dev/null
/opt/userful/bin/mx-config-gen.sh -1box
popd /dev/null
fi
echo $START_MX > /etc/userful/start-mx
elif [ $START_MX -eq 3 ]; then
DETAILED_MSG="(EE) Failed to start Multi-X with normal configuration."
echo "(II) Reconfigure userful.Mxorg.conf with single head configuration" >>  $logfile
while read VIDEOCARD; do
BUSID=`echo $VIDEOCARD | awk -F'^' '{print $1}'`
VENDORNAME=`echo $VIDEOCARD | awk -F'^' '{print $2}'`
BOARDNAME=`echo $VIDEOCARD | awk -F'^' '{print $3}'`
DRIVER=`echo $VIDEOCARD | awk -F'^' '{print $4}'`
DEVID=`echo $VIDEOCARD | awk -F'^' '{print $6}'`
echo "$BUSID^$VENDORNAME^$BOARDNAME^$DRIVER^1^$DEVID" >> /etc/mvgainfo.new
done < /etc/mvgainfo
rm -f /etc/mvgainfo.fail
mv -f /etc/mvgainfo /etc/mvgainfo.fail
mv -f /etc/mvgainfo.new /etc/mvgainfo
rm -f /etc/usbinput
rm -f /etc/X11/xdm/Xservers
if [ -f /root/xorg.conf.new ]; then
/opt/userful/bin/dm-gen-xconfig.sh -1box
else
pushd /opt/userful/bin > /dev/null
/opt/userful/bin/mx-config-gen.sh -1box
popd /dev/null
fi
echo $START_MX > /etc/userful/start-mx
else
DETAILED_MSG="(EE) Failed to start Multi-X with normal configuration."
echo $START_MX > /etc/userful/start-mx
fi
RAGE_DRIVER=`grep "1002:4752" /opt/userful/bin/VGAINFO  | awk '{print $4}'`
if $LSPCI -n | grep "1002:4752" > /dev/null 2>&1 && [ "$RAGE_DRIVER" == "mach64" ]; then
sed -i -e "s/^1002:4752.*/1002:4752 1 S ati [Rage XL]/" /opt/userful/bin/VGAINFO
rm -f /etc/X11/userful.Mxorg.conf
echo "(EE) Use ati driver for Rage XL card." >>  $logfile
fi
/usr/share/umx-utils/submit-debug-info.sh -d "$DETAILED_MSG"
sync;sync;reboot;reboot
exit 1
else 
echo "`date +"%b %d %T"` $ProgramName: Multi-X started." >>  $logfile
echo 0 > /etc/userful/start-mx
/opt/userful/bin/make-config-file -u
if [ -f /opt/userful/bin/umx-mandatory-dev-refresh.sh ]; then
/opt/userful/bin/umx-mandatory-dev-refresh.sh
fi
if which xset > /dev/null 2>&1; then
echo "`date +"%b %d %T"` $ProgramName: xset -display :0 -dpms" >>  $logfile
xset -display :0 -dpms
fi
fi
}
if [ -e /var/run/x.pid ]; then
if [ -e /proc/`cat /var/run/x.pid` ]; then
echo "" >> /var/log/usbinput.log
echo "(WW) Multi X is already running ..." >>  $logfile
rm -f /tmp/mx-trial
sleep 0.1
else
start_1box_server
fi
else
start_1box_server
fi
