#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
source /opt/userful/bin/userful-bash-lib.sh
function get_config() {
local Mode=$1 # direct - global
local User=$2
local File=$3
echo "/home/$User/.kde3/share/config/$File"
}
function save() {
local File="$1"
local Group="$2"
local Key="$3"
local Type="$4"
local Value="$5"
if [ "$Value" == "" ]; then
log "/usr/bin/kwriteconfig --file %s --group %s --key %s --type %s ''" \
"$File" "$Group" "$Key" "$Type"
`/usr/bin/kwriteconfig --file $File --group $Group --key $Key --type $Type ''`
else
log "/usr/bin/kwriteconfig --file %s --group %s --key %s --type %s %s" \
"$File" "$Group" "$Key" "$Type" "$Value"
`/usr/bin/kwriteconfig --file $File --group $Group --key $Key --type $Type $Value`
fi
}
function read() {
local File="$1"
local Group="$2"
local Key="$3"
local result=`/usr/bin/kreadconfig --file $File --group $Group --key $Key`
log "/usr/bin/kreadconfig --file %s --group %s --key %s -> %s" \
"$File" "$Group" "$Key" "$result"
echo $result
}
function add_to_list() {
local List=$1
local Element=$2
local IFS=$',' && local array=( $List ) # convert to line-array
for i in "${array[@]}"; do if [[ "$i" == "${Element}" ]] ; then local exist="$i" ; fi; done
if [ "$exist" != "" ]; then
echo "$List"
else
if [[ "$List" == "" ]] ; then
echo "$Element"
else
echo "$List,$Element"
fi
fi
}
function remove_from_list() {
local List=$1
local Element=$2
local IFS=$',' && local array=( $List ) # convert to line-array
local result=''
for i in "${array[@]}" 
do 
if [[ "$i" != "${Element}" ]] ; then 
if [[ "$result" == "" ]] ; then 
result="$i"
else
result="$result,$i" 
fi
fi
done
echo "$result"
}
function usage() {
echo $(basename $0)
}
function disable_device_icons() {
local User="$1"
local File=$(get_config 'direct' "$User" 'kdesktoprc')
exclude=$(read "$File" 'Media' 'exclude')
log "readed value %s" $exclude	
exclude=$(add_to_list "$exclude" 'media/removable_mounted')
exclude=$(add_to_list "$exclude" 'media/removable_unmounted')
exclude=$(add_to_list "$exclude" 'media/hdd_mounted')
exclude=$(add_to_list "$exclude" 'media/nfs_mounted')
exclude=$(add_to_list "$exclude" 'media/floppy5_unmounted')
exclude=$(add_to_list "$exclude" 'media/cdrom_unmounted')
exclude=$(add_to_list "$exclude" 'media/floppy_unmounted')
exclude=$(add_to_list "$exclude" 'media/hdd_unmounted')
exclude=$(add_to_list "$exclude" 'media/nfs_unmounted')
exclude=$(add_to_list "$exclude" 'media/camera_mounted')
exclude=$(add_to_list "$exclude" 'media/camera_unmounted')
exclude=$(add_to_list "$exclude" 'media/gphoto2camera')
log "new value %s" $exclude	
$(save "$File" 'Media' 'exclude' 'string' "$exclude")
}
function enable_device_icons() {
local User="$1"
local File=$(get_config 'direct' "$User" 'kdesktoprc')
exclude=$(read "$File" 'Media' 'exclude')
log "readed value %s" $exclude	
exclude=$(remove_from_list "$exclude" 'media/removable_mounted')
exclude=$(remove_from_list "$exclude" 'media/removable_unmounted')
exclude=$(remove_from_list "$exclude" 'media/hdd_mounted')
exclude=$(remove_from_list "$exclude" 'media/nfs_mounted')
exclude=$(remove_from_list "$exclude" 'media/floppy5_unmounted')
exclude=$(remove_from_list "$exclude" 'media/cdrom_unmounted')
exclude=$(remove_from_list "$exclude" 'media/floppy_unmounted')
exclude=$(remove_from_list "$exclude" 'media/hdd_unmounted')
exclude=$(remove_from_list "$exclude" 'media/nfs_unmounted')
exclude=$(remove_from_list "$exclude" 'media/camera_mounted')
exclude=$(remove_from_list "$exclude" 'media/camera_unmounted')
exclude=$(remove_from_list "$exclude" 'media/gphoto2camera')
log "new value %s" $exclude	
$(save "$File" 'Media' 'exclude' 'string' "$exclude")
}
function login() {
local User="$1"
$(disable_device_icons "$User")
local File=$(get_config 'direct' "$User" 'kickerrc')
/usr/bin/kwriteconfig --file $File --group "KDE Action Restrictions" --key switch_user --type bool false 
/usr/bin/kwriteconfig --file $File --group "KDE Action Restrictions" --key start_new_session--type bool false 
}
function logout() {
local User="$1"
$(enable_device_icons "$User")
}
main () {
echo starting... $VERBOSE "login=$LOGIN" "logout=$LOGOUT" $@
if [ "" == "$USER" ]; then
USER="$PAM_USER"
fi
if [ "true" == "$LOGIN" ]; then
$(login "$USER")
exit
fi
if [ "true" == "$LOGOUT" ]; then
$(logout "$USER")
exit
fi
}
GETOPT=`getopt -o thvsiou: \
--long test,help,verbose,self:,login,logout,user: \
-n $(basename $0) -- "$@"`
if [ $? -ne 0 ]; then
usage
fi
eval set -- "$GETOPT"
SELF=$0
while [ "$1" != "" ]; do
case "$1" in
-t | --test )     TEST="true";;
-s | --self )     SELF="$2";shift;; # we need it for testing
-v | --verbose )  VERBOSE="true";;  # TODO
-i | --login )      LOGIN="true";;
-o | --logout )    LOGOUT="true";;
-u | --user )      USER="$2";shift;;
-h | --help )     help; exit;;
--)               break ;;
* )               usage; exit 1
esac
shift
done
if [ -z "$TEST" ]; then    
main "${@/--}"
fi
