#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
touch $logfile
chmod a+w $logfile
touch /etc/usbhub
chmod a+r /etc/usbhub
touch /etc/usbinput
chmod a+r /etc/usbinput
touch /etc/usbaudio
chmod a+r /etc/usbaudio
touch /etc/multiuserdevices
chmod a+r /etc/multiuserdevices
if [ -f /tmp/distro.conf ]; then
source /tmp/distro.conf
fi
function update_library() {
mkdir -p /etc/userful/backup
if [ -n "$LIBGL" -a ! -e /usr/local/lib/$LIBGL ]; then
if [ -e /etc/userful/backup/$LIBGL ]; then
cp -f /etc/userful/backup/$LIBGL  /usr/local/lib/
fi
fi
if [ -n "$LIBDRM_INTEL" -a ! -e /usr/local/lib/$LIBDRM_INTEL ]; then
if [ -e /etc/userful/backup/$LIBDRM_INTEL ]; then
cp -f /etc/userful/backup/$LIBDRM_INTEL /usr/local/lib/
fi
fi
if [ -f /opt/userful/bin/userful-bash-lib.sh ]; then
source /opt/userful/bin/userful-bash-lib.sh 
fi
libGLpath=$(check_libGL_path update)
if [ -n "$LIBGL" -a "$libGLpath" != "none" ]; then
libGLbase=`basename $libGLpath`
libGLdir=`dirname $libGLpath`
mv -f $libGLpath /etc/userful/backup/$libGLbase.system
ln -sf /usr/local/lib/$LIBGL $libGLdir/$LIBGL
ln -sf $libGLdir/$LIBGL $libGLdir/libGL.so.1
fi

libdrmintel_path=$(check_libdrmintel_path update)
if [ -n "$LIBDRM_INTEL" -a "$libdrmintel_path" != "none" ]; then
libdrmintel_base=`basename $libdrmintel_path`
libdrmintel_dir=`dirname $libdrmintel_path`
mv -f $libdrmintel_path /etc/userful/backup/$libdrmintel_base.system
ln -sf /usr/local/lib/$LIBDRM_INTEL $libdrmintel_dir/$LIBDRM_INTEL
ln -sf $libdrmintel_dir/$LIBDRM_INTEL $libdrmintel_dir/libdrm_intel.so.1
fi
}
if [ "$PAM_TTY" == "" -o "$PAM_FUNCTION" == "" -o "$PAM_USER" == "" ]; then
echo "`date +"%b %d %T"` $ProgramName: Unable to get all PAM environment variables" >> $logfile
echo "`date +"%b %d %T"` $ProgramName: PAM_TTY=$PAM_TTY, PAM_FUNCTION=$PAM_FUNCTION, PAM_USER=$PAM_USER" >> $logfile
exit 1
fi
if [ "$PAM_FUNCTION"  == "OPEN_SESSION" ]; then
echo "`date +"%b %d %T"` $ProgramName:(Login) `id -u $PAM_USER` login to DISPLAY=$PAM_TTY" >> $logfile
SCREEN_NUM=${PAM_TTY##*:}
SCREEN_NUM=${SCREEN_NUM/.*}
if [ -e /etc/startat ]; then
STARTAT=`cat /etc/startat`
fi
if test x"$STARTAT" == x; then
STATION_NUM=$(($SCREEN_NUM + 1))
else
STATION_NUM=$(($SCREEN_NUM + $STARTAT))
fi
echo "$STATION_NUM" > /opt/userful/locks/station.$PAM_USER
echo "$SCREEN_NUM" > /opt/userful/locks/screen.$PAM_USER
PAM_USER_ID=`id -u $PAM_USER`
echo "$STATION_NUM" > /opt/userful/locks/station.$PAM_USER_ID
echo "$SCREEN_NUM" > /opt/userful/locks/screen.$PAM_USER_ID
echo "$PAM_USER" > /opt/userful/locks/user.screen$SCREEN_NUM
if [ -x /opt/userful/bin/dstv4_change_audio_ownership.sh ]; then
/opt/userful/bin/dstv4_change_audio_ownership.sh $PAM_USER
fi
if [ -x /opt/userful/bin/kde-customization.sh ]; then
:
fi
update_library
elif [ "$PAM_FUNCTION"  == "CLOSE_SESSION" ]; then
echo "`date +"%b %d %T"` $ProgramName:(Logout) `id -u $PAM_USER` logout from DISPLAY=$PAM_TTY" >> $logfile
SCREEN_NUM=${PAM_TTY:1}
SCREEN_NUM=${SCREEN_NUM/.*}
rm -f /opt/userful/locks/station.$PAM_USER
rm -f /opt/userful/locks/screen.$PAM_USER
PAM_USER_ID=`id -u $PAM_USER`
rm -f /opt/userful/locks/station.$PAM_USER_ID
rm -f /opt/userful/locks/screen.$PAM_USER_ID
rm -f /opt/userful/locks/user.screen$SCREEN_NUM
if [ "$PAM_USER" != "root" ]; then
if [ -f /etc/init.d/Userful-Desktop-startup ]; then
:
else
for F in `ls /home/$PAM_USER/Desktop/*.desktop 2> /dev/null`; do
if grep "usbpendrive" $F > /dev/null 2>&1; then
rm -f $F
fi
done
killall -u $PAM_USER
fi
fi
if [ -x /opt/userful/bin/kde-customization.sh ]; then
:
fi
fi
if [ -x /opt/userful/bin/multistation-audio-update-ownership.sh ]; then
/opt/userful/bin/multistation-audio-update-ownership.sh $PAM_TTY $PAM_FUNCTION $PAM_USER
fi
if [ -x /opt/userful/bin/multistation-storage-update-ownership.sh ]; then
/opt/userful/bin/multistation-storage-update-ownership.sh $PAM_TTY $PAM_FUNCTION $PAM_USER
fi
if [ -x /opt/userful/bin/multistation-run-custom-scripts-root.sh ]; then
/opt/userful/bin/multistation-run-custom-scripts-root.sh $PAM_TTY $PAM_FUNCTION $PAM_USER
fi
