#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
log() {
local PROGRAM=$(basename ${BASH_SOURCE[1]})
local LINENO=${BASH_LINENO[0]}
local CALLER=${FUNCNAME[1]}
local TS=`date +"%b %d %T"`
local FORMAT="%s %s:%s:%i:"$1"\n" # TS PROGRAM:CALLER:LINENO:REST
shift
local VALUES=( "$@" ) 	# quote arguments
printf "$FORMAT" "$TS" "$PROGRAM" "$CALLER" "$LINENO" "${VALUES[@]}" >>$logfile
}
logfile="/var/log/userful-start.log" 
function simulate(){
local CMD=$1
log "Simulating \"%s\"" "$CMD"
}
function get_screen_number() {
local DEVICE_SYS_PATH=$1
echo `/opt/userful/bin/get-screen-num-from-devpath -T 12 -P $DEVICE_SYS_PATH 2>/dev/null`
}
function get_user_from_screen() {
local SCREEN_NUM=$1
echo `cat /opt/userful/locks/user.screen$SCREEN_NUM 2>/dev/null`
}
function change_ownership() {
local USER=$1
local LINKS=$2
local PERMITIONS=$3
local LINK=
for LINK in "$LINKS"
do
local CHOWN_CMD="chown $USER $LINK"
local CHMOD_CMD="chmod $PERMITIONS $LINK"
if [ "true" == "$TEST" ];then
$(simulate "$CHOWN_CMD")
$(simulate "$CHMOD_CMD")
else
`$CHOWN_CMD &>/dev/null`
`$CHMOD_CMD &>/dev/null`
fi
done
}
function get_device_name() {
local NAME=$1
local KERNEL=$2	
if [ "$NAME" == "" ]; then
log "Name for device  \"%s\" are not specified will try to find out" \
"$DEVICE_SYS_PATH"
NAME="$KERNEL"
fi
echo "/dev/$NAME"
}
main () {
DEVICE=$(get_device_name "$NAME" "$KERNEL")
SCREEN_NUM=$(get_screen_number "$DEVICE_SYS_PATH")
if [ "$SCREEN_NUM" == "-1" ]; then
log "Cannot find the screen for device \"%s\" skipping." "$DEVICE_SYS_PATH" 
exit
fi
USER_NAME=$(get_user_from_screen $SCREEN_NUM)
if [ "$USER_NAME" == "-1" ]; then
log "Cannot find the user for device \"%s\" skipping." "$DEVICE_SYS_PATH" 
exit
fi
log "Device \"%s\" belongs to user \"%s\"" "$DEVICE_SYS_PATH" "$USER_NAME"
$(change_ownership "$USER_NAME" "$DEVICE" 600)
}
if [ ! -e /var/run/x.pid ]; then
exit 0
elif ! kill -0 `cat /var/run/x.pid` > /dev/null 2>&1; then
exit 0
fi
if [ -e /tmp/X-start ]; then
exit 0
fi
GETOPT=`getopt -o thvsp:n:k: \
--long test,help,verbose,self:,devpath:,name:,kernel: \
-n $(basename $0) -- "$@"`
if [ $? -ne 0 ]; then
usage
fi
eval set -- "$GETOPT"
SELF=$0
while [ "$1" != "" ]; do
case "$1" in
-t | --test )        TEST="true";;
-s | --self )        SELF="$2";shift;; # we need it for testing
-v | --verbose )     VERBOSE="true";;  # TODO
-p | --devpath )     DEVICE_SYS_PATH="$2";shift;;
-n | --name )        NAME="$2";shift;;
-k | --kernel )      KERNEL="$2";shift;;
-h | --help )   help; exit;;
--)                 break ;;
* )             usage; exit 1
esac
shift
done
if [ -z "$TEST" ]; then    
main "${@/--}"
fi
