#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
#
logfile="/var/log/userful-start.log"
CONFIG_FILE="/etc/umx-man-dev"
ProgramName=`basename $0`
if [ -f /etc/userful/userful-license-info ]; then
source /etc/userful/userful-license-info
else
echo "`date +"%b %d %T"` $ProgramName: Unable to find userful-license-info." >> $logfile
rm -f $CONFIG_FILE
exit 1
fi
if [ x"$MANDATORY_DEV" == x ]; then
rm -f $CONFIG_FILE
exit 0
fi
echo "`date +"%b %d %T"` $ProgramName: Mandatory device is enabled. $MANDATORY_DEV" >> $logfile
if [ ! -e /etc/usbinput ]; then
/opt/userful/bin/make-config-file
fi
if [ ! -e /etc/usbinput ]; then
echo "`date +"%b %d %T"` $ProgramName: Unable to find the /etc/usbinput" >> $logfile
rm -f $CONFIG_FILE
exit 1
fi
: > $CONFIG_FILE
chmod a+r $CONFIG_FILE
TOTAL_DEV=`lsusb -v | grep $MANDATORY_DEV | wc -l`
if [ x"$EXTRA_STN" != x ]; then
TOTAL_DEV=$((TOTAL_DEV+EXTRA_STN))
fi
USED_DEV=0
while read line; do
if [ "${line:5:3}" == "kbd" ]; then
if [ "${line:1:1}" == "1" ]; then
USED_DEV=$((USED_DEV+1))
fi
fi
done < /etc/usbinput
AVAIL_DEV=$((TOTAL_DEV-$USED_DEV))
if [ $AVAIL_DEV -lt 0 ];then
AVAIL_DEV=0
fi
echo "TOTAL:$TOTAL_DEV AVAILABLE:$AVAIL_DEV"  > $CONFIG_FILE
#
#
#
#
#
