#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
logfile="/var/log/userful-start.log"
BLKID="/sbin/blkid"
DEVVENDOR=$1
DEVNAME=$2
DESKTOPDIR="Desktop"
USERFUL_SETUP="/etc/userful/setup"
for (( i=0; i<10; i++ )); do
if [ $i -eq 0 ]; then
device_name="/dev/$DEVNAME"
else
device_name="/dev/$DEVNAME$i"
fi
VOLUMENAME=`dbus-send --system --print-reply --dest=com.userful.Storage \
--type=method_call /com/userful/Storage com.userful.Storage.GetAttribute \
string:"$device_name" | grep "string" | awk '{print $2}' | tr -d '":'`
FSTYPE=`dbus-send --system --print-reply --dest=com.userful.Storage \
--type=method_call /com/userful/Storage com.userful.Storage.GetAttribute \
string:"$device_name" | grep "string" | awk '{print $3}' | cut  -d '"' -f2`
if [ -n "$VOLUMENAME" -a -n "$FSTYPE" ]; then
break
fi
done
if [ -z "$VOLUMENAME" ]; then
echo "Unable to find device attribute for /dev/$DEVNAME" >> $logfile
exit 1
fi
USER_ID=`id -u`
GROUP_ID=`id -g`
echo "$DEVNAME, $VOLUMENAME, $FSTYPE, $USER" >> $logfile
MOUNTPOINT="$HOME/.ums/`basename $VOLUMENAME`"
mkdir -p $MOUNTPOINT
ret=`dbus-send --system --print-reply --dest=com.userful.Storage --type=method_call \
/com/userful/Storage com.userful.Storage.Mount string:"$USER_ID" string:"$GROUP_ID" \
string:"$VOLUMENAME" string:"$MOUNTPOINT" string:"$FSTYPE" | grep "boolean" | awk '{print $2}'`
if [ "$ret" != "true" ]; then
echo "Unable to mount: $DEVNAME, $VOLUMENAME, $FSTYPE, $USER" >> $logfile
exit 1
fi
rm -f /$HOME/$DESKTOPDIR/$DEVVENDOR-$DEVNAME.desktop
F_NAME="/$HOME/$DESKTOPDIR/$DEVVENDOR-$DEVNAME.desktop"
cp -f $USERFUL_SETUP/removable_link.desktop $F_NAME
sed -i -e "s^@MOUNTPOINT@^$MOUNTPOINT^" $F_NAME
chmod a+x $F_NAME
F_NAME="/$HOME/$DESKTOPDIR/Desmontar-$DEVVENDOR-$DEVNAME.desktop"
cp -f $USERFUL_SETUP/removable_mounted.desktop $F_NAME
sed -i -e "s/@VENDORNAME@/$DEVVENDOR/"  $F_NAME
sed -i -e "s/@DEVNAME@/$DEVNAME/"  $F_NAME
sed -i -e "s^@MOUNTPOINT@^$MOUNTPOINT^" $F_NAME
chmod a+x $F_NAME
exec konqueror $MOUNTPOINT 
