#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
userful() {
echo "$(dirname "$SELF")"
}
function activate_session() {
local SESSION=$1
local SESSION_ID=${SESSION//\//.}
local SetIsLocal="dbus-send --system --print-reply --dest=org.freedesktop.ConsoleKit \
$SESSION org.freedesktop.DBus.Properties.Set \
string:$SESSION_ID string:is-local variant:boolean:true"
local SetActive="dbus-send --system --print-reply --dest=org.freedesktop.ConsoleKit \
$SESSION org.freedesktop.DBus.Properties.Set \
string:$SESSION_ID string:active variant:boolean:true"
if [ "true" == "$TEST" ];then
$(simulate "$SetIsLocal")
$(simulate "$SetActive")
else
$SetIsLocal  > /dev/null 2>&1
$SetActive  > /dev/null 2>&1
fi
}
function get_local_addresses() {	
echo localhost `/sbin/ifconfig | grep inet | cut -d':' -f2- | sed 's_ __' \
| cut -d' ' -f1 | cut -d'/' -f1`
}
function usage() {
echo Usage:
echo "   $(basename $0) --user=<USER> --display=<DISPLAY>" 
}
function ConsoleKitInit() {
local USER=$1
local DISPLAY=$2
log "Retriving session information"
local USERID=`id -u $USER`
local SESSIONS=`dbus-send --system --print-reply --dest=org.freedesktop.ConsoleKit \
/org/freedesktop/ConsoleKit/Manager \
org.freedesktop.ConsoleKit.Manager.GetSessionsForUnixUser uint32:$USERID \
| grep ConsoleKit | cut -d'"' -f2`
local LOCAL_ADDRESSES=$(get_local_addresses)
log "%s" "$LOCAL_ADDRESSES"
for SESSION in "$SESSIONS"; do
XDISPLAY=`dbus-send --system --print-reply --dest=org.freedesktop.ConsoleKit \
$SESSION org.freedesktop.ConsoleKit.Session.GetX11Display \
| grep string | cut -d'"' -f2`
if [ "$DISPLAY" == "$XDISPLAY" ]; then
log "Check if session for user '%s'(%i) on display %s initiated from one of the local addresses [%s]" \
"$USER" "$USERID" "$DISPLAY" "$LOCAL_ADDRESSES" 
for IP in $LOCAL_ADDRESSES; do
log "Check if session initiated from local address '$IP'"
if echo $XDISPLAY | grep $IP > /dev/null 2>&1 ; then
log "Activating session for user '%s'(%i) on display %s" \
"$USER" "$USERID" "$DISPLAY"
if [ "true" == "$TEST" ];then
$(simulate "activate_session $SESSION")
else
log "Activating session '%s'" "$SESSION"
activate_session "$SESSION"
fi
fi
done
fi
done
}
export logfile=/var/log/userful-start.log
source /opt/userful/bin/userful-bash-lib.sh
main () {
ConsoleKitInit "$USER" "$DISPLAY"
}
if [ $# -eq 0 ]; then
usage
fi
GETOPT=`getopt -o thvsu:d: \
--long test,help,verbose,self:,user:,display: \
-n $(basename $0) -- "$@"`
if [ $? -ne 0 ]; then
usage
fi
eval set -- "$GETOPT"
SELF=$0
while [ "$1" != "" ]; do
case "$1" in
-t | --test )     TEST="true";;
-s | --self )     SELF="$2";shift;; # we need it for testing
-v | --verbose )  VERBOSE="true";;  # TODO
-u | --user )      USER="$2";shift;;
-p | --display )    DISPLAY="$2";shift;;
-h | --help )     help; exit;;
--)               break ;;
* )               usage; exit 1
esac
shift
done
if [ -z "$TEST" ]; then    
main "${@/--}"
fi
