#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
XINITRC="/opt/userful/umx.xinitrc"
UMX_LD_CONF="/etc/userful/umx.ld.conf"
MULTIX_PATH="/opt/MX11R7"
if which lspci > /dev/null 2>&1; then
LSPCI="lspci"
else
LSPCI="/opt/userful/bin/listpci"
fi
function update_mx_config()
{
NUM_OF_HEADS=`cat /etc/X11/stations`
if ! grep "tch" /etc/usbinput > /dev/null 2>&1 ; then
for ((i = 0; i < $NUM_OF_HEADS; i++))
do
TEST=`grep "InputDevice" /etc/X11/userful.Mxorg.conf | grep "Touch$i"`
if [ -n "$TEST" ]; then
sed -i -e "/$TEST/d" /etc/X11/userful.Mxorg.conf
fi
done
elif ! grep "InputDevice" /etc/X11/userful.Mxorg.conf | grep "Touch" > /dev/null 2>&1 ; then
echo "(II) Touchscreen detected. Create userful.Mxorg.conf with touchscreen infomation" >>  $logfile
if [ -f /root/xorg.conf.new ]; then
/opt/userful/bin/dm-gen-xconfig.sh -1box
else
/opt/userful/bin/mx-config-gen.sh -1box
fi
fi
}
function update_ldconf()
{
ldconfig $MULTIX_PATH/lib/
RET=$?
while [[ "$RET" != "0" ]];
do
sleep 1
log "ldconfig has failed. Try again."
ldconfig $MULTIX_PATH/lib/
RET=$?
done
if [ -d /usr/local/lib64 ]; then
ldconfig /usr/local/lib64/
fi
}
source /opt/userful/bin/userful-bash-lib.sh 
init_message "  Starting \E[36mUSERFUL Multiplier\033[0m. Please wait..."
source /etc/userful/MXVERSION
if [ -z "$MXVER" ]; then
log "Unable to find /etc/X11/MXVERSION file. Set MXVER to MX11R7"
MXVER="MX11R7"
fi
if [ -x /opt/userful/bin/waiting-for.sh ]; then
/opt/userful/bin/waiting-for.sh --hub -interval 3
/opt/userful/bin/waiting-for.sh --input -interval 2
fi
if $LSPCI -n | grep "0300:" | tr "a-z" "A-Z" | grep "10DE" > /dev/null 2>&1 ; then
modprobe -q nvidia
fi
/opt/userful/bin/checkPS2
/opt/userful/bin/make-config-file 2>> $logfile
if [ -f /opt/userful/bin/umx-mandatory-dev-refresh.sh ]; then
/opt/userful/bin/umx-mandatory-dev-refresh.sh
fi
update_mx_config
if [ "$MXVER" == "MX11R7" ]; then
export LD_LIBRARY_PATH=/opt/MX11R7/lib
fi
update_ldconf
if [ -f /tmp/distro.conf ]; then
source /tmp/distro.conf
fi
if [ -f /etc/userful/umx.conf ]; then
sed -e "s/^\[/#\[/g" /etc/userful/umx.conf > /tmp/umx.conf.tmp
source /tmp/umx.conf.tmp
fi
if [ "$LOGINTYPE" == "remote" ]; then
TCP_CONNECTION=""
else
TCP_CONNECTION="-nolisten tcp"
fi
IGNOREABI="-ignoreABI"
if [ "$ACCESS_CONTROL" == "enable" ]; then
AC=""
else
AC="-ac"
TCP_CONNECTION=""
fi
if [ "$VIDEO_RESET" == "enable" ]; then
touch /tmp/video-reset
xinit $XINITRC -- /opt/$MXVER/bin/X :0 $IGNOREABI -br -logfile /var/log/1box-server.log $TCP_CONNECTION -config userful.Mxorg.conf
fi
if which date > /dev/null 2>&1; then
date +%s > /tmp/X-start
touch /tmp/waiting-for-x
else
rm -f /tmp/X-start
fi
/opt/userful/bin/waiting-for.sh --xorg mx &
sed -i -e "s/X-KDE-Kded-autoload=true/X-KDE-Kded-autoload=false/" /opt/kde3/share/services/kded/medianotifier.desktop
log "Start %s." "$MXVER"
exec xinit $XINITRC -- /opt/$MXVER/bin/X :0 $IGNOREABI -br -logfile /var/log/1box-server.log $TCP_CONNECTION $AC -config userful.Mxorg.conf -noreset &>/dev/null
