#!/usr/bin/env python
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
import libxml2
import sys
action_ids = ("org.freedesktop.hal.storage.mount-removable", "org.freedesktop.hal.storage.eject")
def add_action_match_element(root_elem, elem, id):
    if elem:
        empty_text = libxml2.newText('\n    ')
        elem.addNextSibling(empty_text)
        newNode = libxml2.newNode('match')
        newNode.setProp('action', id)
        empty_text.addNextSibling(newNode)
        childNode = libxml2.newNode('return')
        childNode.setProp('result', 'yes')
        newNode.addChild(childNode)
    else:
        newNode = libxml2.newNode('match')
        newNode.setProp('action', id)
        root_elem.addChild(newNode)
        childNode = libxml2.newNode('return')
        childNode.setProp('result', 'yes')
        newNode.addChild(childNode)
        empty_text = libxml2.newText('    ')
        newNode.addPrevSibling(empty_text)
        newline_text = libxml2.newText('\n')
        newNode.addNextSibling(newline_text)
def update_polkit_conf(config_file):
    doc = libxml2.parseFile(config_file)
    if doc.name != config_file:
        print "doc.name failed"
        sys.exit(1)
    root_elem = doc.getRootElement()
    match_elem = doc.xpathEval('//match')
    for id in action_ids:
        id_found = False
        elem = None
        for elem in match_elem:
            if elem.hasProp('action') and elem.prop('action') == id:
                child = elem.children
                while child is not None:
                    if child.type == "element" and child.name == 'return' and child.hasProp('result'):
                        child.setProp('result', 'yes')
                    child = child.next
                id_found = True
                break
            else:
                pass
        
        if not id_found:
            add_action_match_element(root_elem, elem, id)
    fd = open(config_file, 'w')
    doc.saveTo(fd)
    fd.close
    doc.freeDoc()
    return
def main():
    command = sys.argv[0]
    if len(sys.argv) != 2:
        print "Usage: " + command + " path_of_PolicyKit.conf"
        return
    
    file = sys.argv[1]
    update_polkit_conf(file)
if __name__ == "__main__":
    main()
