#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
UNLINK=0
DISPLAYNUM=
SCREENNUM=
CURRENTDM=
LOCK_FILE=/tmp/unlink-kbd.lock
if [ -f /opt/userful/debug ] ; then
mkdir -p /var/corefiles
chmod 1777 /var/corefiles
echo "/var/corefiles/core.%u.%s.%e.%t" > /proc/sys/kernel/core_pattern

ulimit -c 50000
else
ulimit -c 0
fi
function usage()
{
echo
echo "Usage: $0 <Screen Number>"
echo
exit 1
}
if [[ -f /etc/userful/umx.conf ]]; then
sed -e "s/^\[/#\[/g" /etc/userful/umx.conf > /tmp/umx.conf.tmp
source /tmp/umx.conf.tmp
fi 
if [ "$CTRLALTBREAK" == "disable" ]; then
echo "`date +"%b %d %T"` $ProgramName: Ctrl-Alt-Break is disabled." >> $logfile
exit 0
fi
if [[ -f /etc/default/locale ]]; then
echo "`date +"%b %d %T"` [$ProgramName]: source locale" >> $logfile
source /etc/default/locale 2>> $logfile
while read line; do
VARS_NAME=`echo $line | awk -F'=' '{print $1}'`
export $VARS_NAME >> $logfile
done < /etc/default/locale
if [[ -f /etc/bash.bashrc ]]; then
source /etc/bash.bashrc
fi
if [[ -f /etc/profile ]]; then
source /etc/profile
fi
if [[ -f /root/.bashrc ]]; then
source /root/.bashrc
fi
if [[ -f /root/.profile ]]; then
source /root/.profile
fi
fi
[[ $# -ne 1 ]] && usage
SCREENNUM=$1
if [[ $SCREENNUM -lt 10 ]]; then
DISPLAYNUM="0$SCREENNUM"
else
DISPLAYNUM=$SCREENNUM
fi
if [[ -f /opt/userful/bin/xkeepalive ]]; then
KEEPALIVE="/opt/userful/bin/xkeepalive"
elif [[ -f /opt/userful/bin/keepalive ]]; then
KEEPALIVE="/opt/userful/bin/keepalive"
else
echo "`date +"%b %d %T"` $ProgramName: Unable to find KEEPALIVE." >> $logfile
exit 1
fi
if [[ -e $LOCK_FILE ]]; then
exit 1
fi
: > $LOCK_FILE
rm -f /etc/usbinput.tmp
[[ -f /etc/profile.d/lang.sh ]] && source /etc/profile.d/lang.sh
if [[ -e /etc/usbinput ]]; then
while read USBINPUT; do
if echo $USBINPUT | grep "Srn#=$DISPLAYNUM" > /dev/null; then
if [[ ${USBINPUT:1:1} -eq 1 ]]; then  # If the current device is configured
USBINPUT=${USBINPUT/1/0}   # replace 1 to 0  (first match)
fi
fi
echo $USBINPUT >> /etc/usbinput.tmp
done < /etc/usbinput
rm -f /etc/usbinput
cp -f /etc/usbinput.tmp /etc/usbinput
/opt/userful/bin/make-config-file -r
else
/opt/userful/bin/make-config-file -r
fi
if [ -f /opt/userful/bin/umx-mandatory-dev-refresh.sh ]; then
/opt/userful/bin/umx-mandatory-dev-refresh.sh
fi
if [ -e /etc/userful/currentdm ]; then
source /etc/userful/currentdm
if [ -z "$CURRENTDM" ]; then
CURRENTDM=gdm
fi
fi
echo "`date +"%b %d %T"` $ProgramName: Unlink keyboard on DISPLAY=:$SCREENNUM, LANG=$LANG" >> $logfile
if [ ! -e /var/run/pid.kbdlink$SCREENNUM -o \
! -d /proc/`cat /var/run/pid.kbdlink$SCREENNUM` ]; then
if [ "$CURRENTDM" == "kdm" -o "$CURRENTDM" == "xdm" ]; then
/opt/userful/bin/checkGrabKeyboard -display :$SCREENNUM
RET=$?
if [ $RET -eq $TRUE ]; then
kill `cat /var/run/pid.login-server$SCREENNUM`
else
if [ -f /opt/userful/debug ] ; then
DISPLAY=:$SCREENNUM /opt/userful/bin/device-assignment -display :$SCREENNUM >> $logfile 2>&1 &
else
/opt/userful/bin/userful-usbinput-config-kill.sh :$SCREENNUM
/opt/userful/bin/userful-usbinput-config -display :$SCREENNUM -r &
fi
fi
else
if [ -f /opt/userful/debug ] ; then
DISPLAY=:$SCREENNUM /opt/userful/bin/device-assignment -display :$SCREENNUM >> $logfile 2>&1 &
else
/opt/userful/bin/userful-usbinput-config-kill.sh :$SCREENNUM                
/opt/userful/bin/userful-usbinput-config -display :$SCREENNUM -r &
fi
fi
sleep 0.5
else
:
fi
if pgrep USBConfigDaemon > /dev/null 2>&1; then
:
else
if [ -z "$CURRENTDM" ]; then
$KEEPALIVE /opt/userful/bin/USBConfigDaemon &
else
$KEEPALIVE /opt/userful/bin/USBConfigDaemon -dm $CURRENTDM &
fi
fi
if pgrep kbd-daemon > /dev/null 2>&1; then
pkill kbd-daemon
else
$KEEPALIVE /opt/userful/bin/kbd-daemon 2>>/var/log/kbd-daemon.log &
fi
if pgrep mse-daemon > /dev/null 2>&1; then
pkill mse-daemon
else
$KEEPALIVE /opt/userful/bin/mse-daemon 2>>/var/log/mse-daemon.log &
fi
if [ -f /opt/userful/debug ] ; then
/usr/bin/killall -s HUP device-assignment
else
/usr/bin/killall -s HUP userful-usbinput-config
fi
rm -f /etc/usbinput.tmp
rm -f  $LOCK_FILE
