#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
NUMOFSTATIONS=
CURRENTDM=
CURRENTXTYPE=
LOCK_FILE="/tmp/usbinput.lock"
if [ -f /opt/userful/bin/xkeepalive ]; then
KEEPALIVE="/opt/userful/bin/xkeepalive"
elif [ -f /opt/userful/bin/keepalive ]; then
KEEPALIVE="/opt/userful/bin/keepalive"
fi
if [ ! -r /proc/kmsg ]; then
echo ""
echo "   You must be logged in as Root to run this program."
echo ""
exit 1
fi
if [ ! -d /var/log/userful ]; then
mkdir /var/log/userful
fi
ALL_HEAD=`cat /etc/X11/stations`
S_NUM=`cat /etc/stations`
if [ $S_NUM -ge $ALL_HEAD ]; then
NUMOFSTATIONS=$ALL_HEAD
else
NUMOFSTATIONS=$S_NUM
fi
if [[ -f /etc/usbinput.static ]]; then
rm -f /etc/usbinput.static
fi
if [[ -x /opt/userful/bin/userful-input-command.sh ]]; then
/opt/userful/bin/userful-input-command.sh -static disable
fi
while ! (set -C; : > $LOCK_FILE) 2> /dev/null; do
sleep 0.2
done
: > /etc/usbinput.tmp
if [ -e /etc/usbinput ]; then
while read USBINPUT; do
if [ ${USBINPUT:1:1} -eq 1 ]; then  # If the current device is configured
USBINPUT=${USBINPUT/1/0}   # replace 1 to 0  (first match)
fi
echo $USBINPUT >> /etc/usbinput.tmp
done < /etc/usbinput
rm -f /etc/usbinput
cp -f /etc/usbinput.tmp /etc/usbinput
/opt/userful/bin/make-config-file -r
else
/opt/userful/bin/make-config-file -r
fi
if [ -f /opt/userful/bin/umx-mandatory-dev-refresh.sh ]; then
/opt/userful/bin/umx-mandatory-dev-refresh.sh
fi
rm -f $LOCK_FILE
echo "`date +"%b %d %T"` $ProgramName: Device reassignment" >> $logfile
if [ -e /etc/userful/currentdm ]; then
source /etc/userful/currentdm
if [ -z "$CURRENTDM" ]; then
CURRENTDM=gdm
fi
fi
if [ "$CURRENTDM" == "kdm" -o "$CURRENTDM" == "xdm" ]; then
for ((i = 0; i < $NUMOFSTATIONS; i++))
do
if [ -e /var/run/pid.kbdlink$i ]; then
pid=`cat /var/run/pid.kbdlink$i`
if [ -d /proc/$pid ]; then
continue
fi
fi
/opt/userful/bin/userful-usbinput-config -display :$i -r > /var/log/userful/usbinput-config.log 2>&1 &
done
sleep 1;
else
for ((i = 0; i < $NUMOFSTATIONS; i++))
do
if [ -e /var/run/pid.kbdlink$i ]; then
if [ -e /proc/`cat /var/run/pid.kbdlink$i` ]; then
:
else
/opt/userful/bin/userful-usbinput-config-kill.sh :$i
/opt/userful/bin/userful-usbinput-config -display :$i -r > /var/log/userful/usbinput-config.log 2>&1 &
fi
else  
/opt/userful/bin/userful-usbinput-config-kill.sh :$i            
/opt/userful/bin/userful-usbinput-config -display :$i -r > /var/log/userful/usbinput-config.log 2>&1 &
fi
done
fi
sleep 1
/usr/bin/killall -s USR1 userful-usbinput-config
if pgrep USBConfigDaemon > /dev/null 2>&1; then
:
else
if [ -z "$CURRENTDM" ]; then
$KEEPALIVE /opt/userful/bin/USBConfigDaemon &
else
$KEEPALIVE /opt/userful/bin/USBConfigDaemon -dm $CURRENTDM &
fi
fi
if pgrep kbd-daemon > /dev/null 2>&1; then
pkill kbd-daemon
else
$KEEPALIVE 	/opt/userful/bin/kbd-daemon 2>>/var/log/kbd-daemon.log &
fi
if pgrep mse-daemon > /dev/null 2>&1; then
pkill mse-daemon
else
$KEEPALIVE /opt/userful/bin/mse-daemon 2>>/var/log/mse-daemon.log &
fi
sleep 1
/usr/bin/killall -s HUP userful-usbinput-config
rm -f /etc/usbinput.tmp
