#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
function Print_Log()
{
if [ $# -lt 2 ]; then
echo "Invalid number of arguments"
fi
local msg=$1
local logfile=$2
echo "`date +"%b %d %T"` $msg" >> $logfile
}
function IsRoot()
{
if [ ! -r /proc/kmsg ]; then
echo ""
echo "You must be logged in as Root to run this program."
echo ""
exit 1
fi
}
#
function Check_System_Type()
{
case $(uname -m) in
x86_64|ia64)
echo "lib64"
;;
*)
echo "lib"
;;
esac
}
#
function Check_nVidia_Driver()
{
LIB=$(Check_System_Type)
modprobe -q nvidia
if lsmod | grep -q "^nvidia"; then
echo "true"
if [ ]; then
if [ -f /usr/$LIB/xorg/modules/drivers/nvidia_drv.o ] && \
[ ! -L /usr/$LIB/xorg/modules/drivers/nvidia_drv.o ]; then
echo "true" 
elif [ -f /usr/$LIB/xorg/modules/drivers/nvidia_drv.so ] && \
[ ! -L /usr/$LIB/xorg/modules/drivers/nvidia_drv.so ]; then
echo "true" 
elif [ -f /usr/$LIB/xorg/modules/drivers/nvidia_drv.so ] && \
[ -f /usr/$LIB/nvidia-current/xorg/nvidia_drv.so ]; then
echo "true" 
elif [ -f /usr/$LIB/xorg/modules/updates/drivers/nvidia_drv.o ] && \
[ ! -L /usr/$LIB/xorg/modules/updates/drivers/nvidia_drv.o ]; then
echo "true" 
elif [ -f /usr/$LIB/xorg/modules/updates/drivers/nvidia_drv.so ] && \
[ ! -L /usr/$LIB/xorg/modules/updates/drivers/nvidia_drv.so ]; then
echo "true" 
elif [ -f /usr/$LIB/xorg/modules/drivers/nvidia-current/nvidia_drv.so ] && \
[ ! -L /usr/$LIB/xorg/modules/drivers/nvidia-current/nvidia_drv.so ]; then
echo "true" 
elif [ -f /usr/X11R6/$LIB/modules/drivers/nvidia_drv.o ] && \
[ ! -L /usr/X11R6/$LIB/modules/drivers/nvidia_drv.o ]; then
echo "true" 
elif [ -f /usr/X11R6/$LIB/modules/drivers/nvidia_drv.so ] && \
[ ! -L /usr/X11R6/$LIB/modules/drivers/nvidia_drv.so ]; then
echo "true" 
elif [ -f /usr/X11R6/$LIB/modules/updates/drivers/nvidia_drv.o ] && \
[ ! -L /usr/X11R6/$LIB/modules/updates/drivers/nvidia_drv.o ]; then
echo "true" 
elif [ -f /usr/X11R6/$LIB/modules/updates/drivers/nvidia_drv.so ] && \
[ ! -L /usr/X11R6/$LIB/modules/updates/drivers/nvidia_drv.so ]; then
echo "true" 
else
echo "false" 
fi
fi
else
echo "false"
fi
}
function showVideoCards()
{
echo -e "\nDetected video card(s):"
CNT=1
while read line; do
raw_bus_id=`echo $line | awk '{print $1}'`
if [[ ${#raw_bus_id} -gt 7 ]]; then
bus_id=${raw_bus_id: -7}
else
bus_id=$raw_bus_id
fi
dev_id=`echo $line | awk '{print $3}'`
if [[ "$dev_id" == "0300:" ]]; then
dev_id=`echo $line | awk '{print $4}'`
fi
dev_str=`lspci -s $bus_id`
dev_str=${dev_str#$raw_bus_id }
echo -e "   Card #$CNT - BUS_ID=$bus_id, DEVICE_ID=$dev_id, \"$dev_str\""
CNT=$(( CNT + 1 ))
done < <(lspci -n | grep "0300: ")
echo ""
}
log() {
local PROGRAM=$(basename ${BASH_SOURCE[1]})
local LINENO=${BASH_LINENO[0]}
local CALLER=${FUNCNAME[1]}
local TS=`date +"%b %d %T"`
local FORMAT="%s %s:%s:%i:"$1"\n" # TS PROGRAM:CALLER:LINENO:REST
shift
local VALUES=( "$@" ) 	# quote arguments
local logfile="/var/log/userful-start.log"
printf "$FORMAT" "$TS" "$PROGRAM" "$CALLER" "$LINENO" "${VALUES[@]}" >>$logfile
}
function version_more_then()
{
local VER1_STR=${1/-/.} # what we comparing
local VER2_STR=${2/-/.} # we compare with
local VER1=(${VER1_STR//./ })
local VER2=(${VER2_STR//./ })
local SIZE1=${#VER1[@]}
local SIZE2=${#VER2[@]}
if [ "$SIZE1" -lt "$SIZE2" ]; then
SIZE=$SIZE1
else
SIZE=$SIZE2
fi
for (( I=0; I<=SIZE-1; I++ )) 
do
if [ "${VER1[I]}" -lt "${VER2[I]}" ]; then #lt
echo false
return 0
fi
done
echo true
return 0
}
function init_message() 
{
local MESSAGE=$1
INIT_VERSION=`init --version 2> /dev/null | grep upstart | sed -s 's/[^(]*(upstart \([^)]*\))/\1/g'`
if [ -n "$INIT_VERSION" ]; then
Res=$(version_more_then "$INIT_VERSION" "0.3.10-2")	
else
Res=true # we have not upstart based init 
fi
if [ true == "$Res" ]; then
echo -e "$MESSAGE"
fi
}
function check_libGL_path()
{
local action=$1
searchpath[0]="/usr/lib64/nvidia-current"
searchpath[1]="/usr/lib/nvidia-current"
searchpath[2]="/usr/X11R6/lib64"
searchpath[3]="/usr/X11R6/lib"
searchpath[4]="/usr/lib64/mesa"
searchpath[5]="/usr/lib/mesa"
searchpath[6]="/usr/lib64"
searchpath[7]="/usr/lib"
index=0
count=${#searchpath[@]}
while [ "$index" -lt "$count" ]
do
if [ -L ${searchpath[index]}/libGL.so ]; then
if [ "$action" == "update" ]; then
for F in `ls ${searchpath[index]}/libGL.so.* 2> /dev/null`; do
if [ ! -L $F ]; then
echo $F
return
fi
done
elif [ "$action" == "restore" ]; then
echo "${searchpath[index]}"
return
fi
fi
((index++))
done
echo "none"
}
function check_libdrmintel_path()
{
local action=$1
searchpath[0]="/lib64"
searchpath[1]="/lib"
searchpath[2]="/usr/X11R6/lib64"
searchpath[3]="/usr/X11R6/lib"
searchpath[4]="/usr/lib64/mesa"
searchpath[5]="/usr/lib/mesa"
searchpath[6]="/usr/lib64"
searchpath[7]="/usr/lib"
index=0
count=${#searchpath[@]}
while [ "$index" -lt "$count" ]
do
if [ -L ${searchpath[index]}/libdrm_intel.so.1 ]; then
if [ "$action" == "update" ]; then
for F in `ls ${searchpath[index]}/libdrm_intel.so.* 2> /dev/null`; do
if [ ! -L $F ]; then
echo $F
return
fi
done
elif [ "$action" == "restore" ]; then
echo "${searchpath[index]}"
return
fi
fi
((index++))
done
echo "none"
}
function gen_distro_conf()
{
local osname=$1
local osver=$2
if [ ! -e /tmp/distro.conf ]; then
if [ -f /etc/userful/umx-distro.conf -a -x /opt/userful/bin/umx-distro-conf.py ]; then
res=`/opt/userful/bin/umx-distro-conf.py --osname $osname --osver $osver \
--in /etc/userful/umx-distro.conf --out /tmp/distro.conf`
if [ "$res" ]; then
log "%s" "$res"
fi
else
log "umx-distro.conf or umx-distro-conf.py is not available."
fi
fi
}
function gen_gconf_conf()
{
local osname=$1
local osver=$2
rm -f /tmp/gconf.conf
if [ -e /etc/userful/umx-gconf.conf ]; then
for S in "common" "$osname $osver"; do
section_flag="off"
while read LINE; do
if [ "$section_flag" == "on" ]; then
if [ "${LINE:0:1}" == "[" ]; then
section_flag="off"
else
if [ ${#LINE} -ne 0 -a "${LINE:0:1}" != "#"  ]; then
echo $LINE >> /tmp/gconf.conf
fi
fi
fi
if [ "$LINE" == "[$S]" ]; then
section_flag="on"
continue
fi
done < /etc/userful/umx-gconf.conf
done
fi
}
