#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
function usage()
{
echo ""
echo "Usage: userful ctrlaltbreak [OPTION]"
echo ""
echo -e "\tOPTIONS:"
echo -e "\t\t-h"
echo -e "\t\t-help\t\t- Print this help message"
echo -e "\t\t-enable\t\t- Enable Ctrl-Alt-Break functionality"
echo -e "\t\t-disable\t- Disable Ctrl-Alt-Break functionality"
echo ""
exit 1
}
function toggleCtrlAltBreak()
{
[[ -z $1 ]] && usage
if [[ "$1" == "-enable" ]]; then
echo -e "\nEnable Ctrl-Alt-Break functionality..\n"
configtype="enable"
elif [[ "$1" == "-disable" ]]; then
echo -e "\nDisable Ctrl-Alt-Break functionality..\n"
configtype="disable"
fi
if grep "^[[:space:]]*CTRLALTBREAK=" /etc/userful/umx.conf > /dev/null 2>&1; then
sed -i -e "s/^[[:space:]]*CTRLALTBREAK=.*/CTRLALTBREAK=$configtype/g" /etc/userful/umx.conf
elif grep "^[[:space:]]*#[[:space:]]*CTRLALTBREAK=" /etc/userful/umx.conf > /dev/null 2>&1; then
sed -i -e "s/^[[:space:]]*#[[:space:]]*CTRLALTBREAK=.*/CTRLALTBREAK=$configtype/g" /etc/userful/umx.conf
else
echo "CTRLALTBREAK=$configtype" >> /etc/userful/umx.conf
fi
}
source /opt/userful/bin/userful-bash-lib.sh
#
IsRoot
[[ -z $1 ]] && usage
case "$1" in
-h|-help)
usage
;;
-enable|-disable)
toggleCtrlAltBreak $1
;;
*)
echo -e "\nError: Invalid option - $1"
usage
;;
esac
