#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
logfile="/var/log/userful-start.log"
usbinput_logfile="/var/log/usbinput.log"
ProgramName=`basename $0`
LOCK_FILE="/tmp/usbinput.lock"
if [[ ! -e /var/run/x.pid ]]; then
exit 1
elif ! kill -0 `cat /var/run/x.pid` > /dev/null 2>&1; then
exit 1
fi
if [[ -e /tmp/X-start ]]; then
exit 1
fi
if [ ! -e /var/run/pid.usbconfigdaemon -o ! -d /proc/`cat /var/run/pid.usbconfigdaemon` ]; then
exit 1
fi
if [ -f /etc/sysconfig/xtype ]; then
source /etc/sysconfig/xtype
if [ "$XTYPE" = "SINGLE" -o "$XTYPE" = "single" ]; then
exit 1
fi
fi
killall -USR1 userful-usbinput-config
touch /tmp/input-hotplug
echo "`date +"%b %d %T"` $ProgramName: Add new device $1" >> $usbinput_logfile
echo "`date +"%b %d %T"` $ProgramName: Add new device $1, $PHYSDEVPATH" >> $logfile
while ! (set -C; : > $LOCK_FILE) 2> /dev/null; do
sleep 0.2
done
if [[ -f /etc/userful/umx.conf ]]; then
sed -e "s/^\[/#\[/g" /etc/userful/umx.conf > /tmp/umx.conf.tmp
source /tmp/umx.conf.tmp
fi
if [ "$DEVCONF" == "static" ]; then
if [ -f /etc/usbinput.static ]; then
cp -f /etc/usbinput.static /etc/usbinput
fi
fi
/opt/userful/bin/make-config-file -r
if [[ -e /etc/usbinput ]]; then
chmod a+r /etc/usbinput
fi
if [ -f /opt/userful/bin/umx-mandatory-dev-refresh.sh ]; then
/opt/userful/bin/umx-mandatory-dev-refresh.sh
fi
rm -f $LOCK_FILE
pkill -USR2 MXSigDaemon
pkill -USR2 kbd-daemon
pkill -USR2 mse-daemon
killall -HUP userful-usbinput-config
