#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
logfile="/var/log/userful-start.log"
usbinput_logfile="/var/log/usbinput.log"
ProgramName=`basename $0`
LOCK_FILE="/tmp/usbinput.lock"
DEV_NAME=
DEV_NUM=
DEV_STR=
DEV_TYPE=
UNPLUG_DEVICE=
PROTOCOL=
SCREENNUM=
TRUE=1
FALSE=0
if [[ ! -e /var/run/x.pid ]]; then
exit 1
elif ! kill -0 `cat /var/run/x.pid` > /dev/null 2>&1; then
exit 1
fi
if [[ -e /tmp/X-start ]]; then
exit 1
fi
function unplug_primary()
{
while ! (set -C; : > $LOCK_FILE) 2> /dev/null; do
sleep 0.2
done
rm -f /tmp/unplug.tmp.$SCREENNUM
while read USBINPUT; do
if echo "$USBINPUT" | grep "Srn#=$SCREENNUM" > /dev/null; then
if [ ${USBINPUT:1:1} -eq 1 ]; then  # If the current device is configured
USBINPUT=${USBINPUT/1/0}   # replace 1 to 0  (first match)
fi
fi
echo "$USBINPUT" >> /tmp/unplug.tmp.$SCREENNUM
done < /etc/usbinput
cp -f /tmp/unplug.tmp.$SCREENNUM /etc/usbinput
/opt/userful/bin/make-config-file -r
if [ -f /opt/userful/bin/umx-mandatory-dev-refresh.sh ]; then
/opt/userful/bin/umx-mandatory-dev-refresh.sh
fi
if [ ! -e /tmp/.X11-unix/X$((10#$SCREENNUM)) ]; then
rm -f $LOCK_FILE
return
fi
if [ -f /etc/userful/currentdm ]; then
source /etc/userful/currentdm
else
CURRENTDM=gdm
fi
if [[ -f /etc/default/locale ]]; then
echo "`date +"%b %d %T"` [$ProgramName]: source locale" >> $logfile
source /etc/default/locale 2>> $logfile
while read line; do
VARS_NAME=`echo $line | awk -F'=' '{print $1}'`
export $VARS_NAME >> $logfile
done < /etc/default/locale
if [[ -f /etc/bash.bashrc ]]; then
source /etc/bash.bashrc
fi
if [[ -f /etc/profile ]]; then
source /etc/profile
fi
if [[ -f /root/.bashrc ]]; then
source /root/.bashrc
fi
if [[ -f /root/.profile ]]; then
source /root/.profile
fi
fi
if [ ! -e /var/run/pid.kbdlink$((10#$SCREENNUM)) -o \
! -d /proc/`cat /var/run/pid.kbdlink$((10#$SCREENNUM))` ]; then
if [ "$CURRENTDM" == "kdm" -o "$CURRENTDM" == "xdm" ]; then
/opt/userful/bin/checkGrabKeyboard -display :$((10#$SCREENNUM))
RET=$?
if [ $RET -eq $TRUE ]; then
kill `cat /var/run/pid.login-server$((10#$SCREENNUM))`
else
/opt/userful/bin/userful-usbinput-config-kill.sh :$((10#$SCREENNUM))
/opt/userful/bin/userful-usbinput-config -display :$((10#$SCREENNUM)) -r &
fi
else
/opt/userful/bin/userful-usbinput-config-kill.sh :$((10#$SCREENNUM))
/opt/userful/bin/userful-usbinput-config -display :$((10#$SCREENNUM)) -r &
fi
else
:
fi
rm -f $LOCK_FILE
}
usage()
{
echo
echo "Usage: $0 <device name>"
echo
exit 1
}
#
#
if [ -f /etc/sysconfig/xtype ]; then
source /etc/sysconfig/xtype
if [ "$XTYPE" = SINGLE -o "$XTYPE" = single ]; then
exit 1
fi
fi
if [ ! -e /var/run/pid.usbconfigdaemon -o ! -d /proc/`cat /var/run/pid.usbconfigdaemon` ]; then
exit 1
fi
if [ $# -ne 1 ]; then
usage
fi
touch /tmp/input-hotplug
echo "`date +"%b %d %T"` $ProgramName:  $1 removed." >> $usbinput_logfile
echo "`date +"%b %d %T"` $ProgramName:  $1 removed." >> $logfile
if [[ -e /etc/userful/umx.conf ]]; then
sed -e "s/^\[/#\[/g" /etc/userful/umx.conf > /tmp/umx.conf.tmp
source /tmp/umx.conf.tmp
fi
if [ "$DEVCONF" == "static" ]; then
echo "`date +"%b %d %T"` $ProgramName: Current device config type is static. Do nothing." >> $logfile
exit 0
fi
DEV_NAME=$1 # event device
DEV_NUM=${DEV_NAME#event}  # event device number
if [ $DEV_NUM -lt 10 ]; then
DEV_STR="Dev#=00$DEV_NUM"
elif [ $DEV_NUM -lt 100 ]; then
DEV_STR="Dev#=0$DEV_NUM"
else
DEV_STR="Dev#=$DEV_NUM"
fi
UNPLUG_DEVICE=`grep "$DEV_STR" /etc/usbinput`
if [ -z "$UNPLUG_DEVICE" ];then
exit 1 # no entry in the usbinput file. may not a real input device
fi
SCREENNUM=${UNPLUG_DEVICE:32:2}
PROTOCOL=${UNPLUG_DEVICE:40:2}
DEVPATH=${UNPLUG_DEVICE:64}
case "$PROTOCOL" in
"01" ) 
DEV_TYPE="keyboard"
;;
"02" ) 
DEV_TYPE="mouse"
;;
"03" ) 
DEV_TYPE="barcode"
;;
"04" ) 
DEV_TYPE="magnetic"
;;
"05" ) 
DEV_TYPE="touch"
;;
*)
echo "`date +"%b %d %T"` $ProgramName: Unplugging input device. Invalid device. protocol=$PROTOCOL." >> $logfile
exit 1
;;
esac
if [[ $PRIMARY_INPUT = *$DEV_TYPE* ]]; then
unplug_primary
else
/opt/userful/bin/make-config-file -u
if [[ $PROTOCOL = 05 ]];then
/opt/userful/bin/send_signal
fi
fi
if 0; then
case "$PROTOCOL" in
"01" ) 
unplug_primary
;;
"02"|"03"|"04" ) 
/opt/userful/bin/make-config-file -u
;;
"05" ) 
/opt/userful/bin/make-config-file -u
/opt/userful/bin/send_signal
;;
esac
fi
pkill -USR2 kbd-daemon
pkill -USR2 mse-daemon
