#!/bin/bash
# Copyright (c) 2005-2011 Userful Corporation.  All rights reserved.
#
#
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`
usage()
{
echo
echo "Usage: $ProgramName <static|dynamic>"
echo
exit 1
}
if [ $UID != 0 ]; then
echo ""
echo "   You must be root to configure devices."
echo ""
exit 1
fi
if [ $# -ne 1 ]; then
usage
fi
CONFIG_TYPE="$1"
echo "`date +"%b %d %T"` $ProgramName: Change the type of device configuration to $1 " >> $logfile
if [ "$CONFIG_TYPE" == "static" ]; then
cp -f /etc/usbinput /etc/usbinput.static
elif [ "$CONFIG_TYPE" == "dynamic" ]; then
rm -f /etc/usbinput.static
else
echo "`date +"%b %d %T"` $ProgramName: $1 is not a valid argument." >> $logfile
echo "$1 is not a valid argument."
exit 1
fi
if grep "\#[[:space:]]*DEVCONF=" /etc/userful/umx.conf > /dev/null 2>&1; then
sed -i -e "s/#[[:space:]]*DEVCONF=.*/DEVCONF=\"$CONFIG_TYPE\"/g" /etc/userful/umx.conf
elif grep "DEVCONF=" /etc/userful/umx.conf > /dev/null 2>&1; then
sed -i -e "s/DEVCONF=.*/DEVCONF=\"$CONFIG_TYPE\"/g" /etc/userful/umx.conf
else
echo "DEVCONF=\"$CONFIG_TYPE\"" >> /etc/userful/umx.conf
fi
echo "Set the assignment type to $CONFIG_TYPE.. Done !"
